;copywrite 2001 Samuel Stearley



debug MACRO	
	move #1,ccr
\l:
	bcs.s	\l

 ENDM


ti89

 ifnd ti89
ti92plus
 endc


	include	"os.h"

 ifd ti89
	xdef		_ti89
 endc

 ifd ti92plus
	xdef		_ti92plus
 endc


	xdef		_nostub




;---INSTALL MY EVENT HOOK----

	movem.l	d3-d7/a2-a6,-(a7)
	move.l	a7,d7				;save stack pointer
	move.l	200,a6			;pointer to the jump table

;----Force home application to start----

	move.l	824(a6),a0		;get send event call
	pea		event2(pc)
	move.w	#-2,-(a7)		;current app
	jsr		(a0)

;----get and install the home applications window id number---

	move.l	(a6),a0		;get pointer to the first window pointer
	move.l	(a0),a0		;now get a pointer to the first window
	lea		compare_opcode+2(pc),a1;get pointer to operand part
	move.w	6(a0),(a1)		;move app id of home app into my code.
	addq.l	#1,a0			;point it to byte with active flag
	lea		tst_opcode+2(pc),a1
	move.w	a0,(a1)

;----alocate memory and copy code to it--------

	move.l	2700(a6),a5			;got pointer to old evhook
	lea		old_event(pc),a1		;get pointer to the save space
	move.l	(a5),(a1)			;save it
	move.l	#END_OF_HOOK-BEGINNING_OF_HOOK,d3	;amount of ram needed
	move.l	d3,-(a7)			;ram needed to copy code too
	move.l	584(a6),a0			;get heap allocate high call
	jsr		(a0)				;allocate it -d0 has the handle
	pea		error_message(pc)
	tst.w		d0				;check for success
	beq.s		memory_error
	move.w	d0,-(a7)			;push for dereferencing
	move.l	600(a6),a0			;get dereference call -ao points to allocated memory
	jsr		(a0)
	move.l	a0,a1
	add.l		#$40010,a0			;increase the first to bypass hw2 protection
	move.l	a0,(a5)			;overwrite old event handler
	subq.l	#1,d3				;for dbra
	lea		BEGINNING_OF_HOOK(pc),a0
copy_loop:
	move.b	(a0)+,(a1)+
	dbra		d3,copy_loop		;copy over the handler
	pea		message(pc)
memory_error:
	move.l	920(a6),a0			;help displag call
	jsr		(a0)

;---Restore Registers and exit the installation-----

final:
	move.l	d7,a7				;reset the stack
	movem.l	(a7)+,d3-d7/a2-a6		;get registers back
	rts

;-----STRINGS-------

error_message:	dc.b	"Not enough memory",0
message:		dc.b	"CtoH by Samuel Stearley (c) 2001",0

	EVEN	

event2:
	dc.w		$710			;keypress event
	dc.w		0			;sender 		-will be filled by send event
	dc.w		0			;side is 0		-will be filled by send event
	dc.w		0			;status flags	-will be filled by send event
	dc.w		0
	dc.w		4360			;quit ekeypress





;---------------------------------
;NOW THE CODE OF THE HOOK
;---------------------------------


	EVEN	


BEGINNING_OF_HOOK:

			dc.b		"evHkCopyToHs"
old_event:		dc.l		0		

;----Check for the right circumstances----

	move.l	4(a7),a2
	move.l	a3,-(a7)


 ifd ti89
	lea		alpha_indic(pc),a3
	cmp.w		#$710,(a2)			;is it command keypress?
	beq.s		check_home			;then we check if on is pressed
	btst.b	#3,7(a2)			;so is alpha being pressed?
	beq		no_alpha
	st.b		(a3)				;signify that it was alpha
	bra		call_next_hook
check_home:
	cmp.w		#277,10(a2)			;see if home was pressed.
	bne		not_key_so_clear_alpha
	tst.b		(a3)				;Home was pressed but was alpha pressed?
	beq		call_next_hook
 endc



 ifd ti92plus
	cmp.w		#$710,(a2)
	bne		call_next_hook
	cmp.w		#8282,10(a2)		;is it diamond+z
	bne		call_next_hook
 endc

;----Evaluate the stuff in the clipboard and put it to history------

	movem.l	a6/d6/d7,-(a7)
	move.l	200,a6
	move.l	1060(a6),a0
	move.l	(a0),-(a7)			;put top of estack onto the stack
	move.l	a7,d7



;----See if it was a dialong box covoring the home app and-------
;----if it was then do nothing.


	move.l	(a6),a0
	move.l	(a0),a0			;get pointer to the first window
compare_opcode:
	cmp.w		#$1234,6(a0)		;is it over the home window
	bne.s		proceed
tst_opcode:
	tst.b		$1234				;is the home app active

	bpl.s		error				;pass on event and clear the alpha indic


;----Get the data items of the clipboard-----------

proceed:
	pea		long(pc)			;push pointer to a long
	pea		handle(pc)			;push the place to store the handle
	move.l	776(a6),a0			;get cb fetch text
	jsr		(a0)

;---Enlarge the handle for the zero terminator------

	move.l	long(pc),d0			;get the size
	beq.s		error
	addq.l	#1,d0	
	move.l	d0,-(a7)
	move.l	handle(pc),-(a7)		;put handle	
	move.l	628(a6),a0			;get heap reallocate
	jsr		(a0)
	move.l	600(a6),a0
	jsr		(a0)				;get pointer to that reallocated block
	move.l	long(pc),d0
	clr.b		0(A0,d0)			;zero terminate it

;---Push it to the estack and evaluate it--------

	move.l	a0,-(a7)
	move.l	3880(a6),a0			;get push parse text
	jsr		(a0)				;push and parse
	tst.w		d0				;check for error
	beq.s		error
	move.l	1060(a6),a0
	move.l	(a0),-(a7)			;put top of estack onto the stack
	move.l	2428(a6),a0			;get ng_rationalize
	jsr		(a0)				;rationalize it


;----Put it to the history-----------

	move.l	1084(a6),a0			;get HomePushEstack
	jsr		(a0)				;so put data to the history

error:
	move.l	1060(a6),a0
	move.l	d7,a7				;reset stack
	move.l	(a7)+,(a0)			;reset the estack
	move.w	#$700,(a2)			;comand idle
	movem.l	(a7)+,a6/d6/d7


;----Call the Next event hook if there is one-----------------------


 ifd ti89
not_key_so_clear_alpha:
no_alpha:
	clr.b		(a3)
 endc


call_next_hook:
	move.l	old_event(pc),a0		;get the old event handler
	move.l	a0,d0				;test it
	beq.S		no_old_hook
	move.l	a2,-(a7)			;input for the event handler
	jsr		(a0)				;call the next event handler
	addq.l	#4,a7				;pop it off
no_old_hook:
	move.l	(a7)+,a3			;get it back
	rts

;----The data----------

 even	

long:
	dc.l		0

handle:
	dc.w		0

 ifd ti89
alpha_indic:
	dc.b		0
 endc

END_OF_HOOK:





	END		

